/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.fw.file.annotation;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * o͐ݒp̃Ame[VB
 * 
 * 
 */
@Retention(RetentionPolicy.RUNTIME)
@Documented
@Target(ElementType.TYPE)
public @interface FileFormat {
    /**
     * s؂蕶B
     * <p>
     * s؂蕶ݒ肷Bs؂蕶͔pɌBȂAGXP[vV[PXgs؂蕶͈ȉɋ̂ɌB<br>
     * <ul>
     * <li>\r</li>
     * <li>\n</li>
     * <li>\r\n</li>
     * </ul>
     * ftHgl͎sɈˑB
     * </p>
     */
    String lineFeedChar() default "";

    /**
     * ؂蕶B
     * <p>
     * CSV,ϒt@C̋؂蕶ݒ肷B؂蕶͔pɌB<br>
     * ftHgĺu','iJ}jvB
     * </p>
     */
    char delimiter() default ',';
    
    /**
     * ͂ݕB
     * <p>
     * CSV,ϒt@C̈͂ݕݒ肷B͂ݕ͔pɌB<br>
     * u'\u0000'ichar^̍ŏljvݒ肷ƁAt[[N͈͂ݕƔfB
     * ftHgĺu'\u0000'ichar^̍ŏljvB
     * </p>
     */
    char encloseChar() default Character.MIN_VALUE;

    /**
     * t@CGR[fBOB
     * <p>
     * o͂st@C̃GR[fBOݒ肷B<br>
     * ftHgl͎sɈˑB
     */
    String fileEncoding() default "";

    /**
     * wb_sB
     * <p>
     * ̓t@C̃wb_ɑsݒ肷B<br>
     * ftHgĺu0i[jvB
     */
    int headerLineCount() default 0;

    /**
     * gCsB
     * <p>
     * ̓t@C̃gCɑsݒ肷B<br>
     * ftHgĺu0i[jvB
     * </p>
     */
    int trailerLineCount() default 0;

    /**
     * ㏑tOB
     * <p>
     * o̓t@CƓt@C݂ꍇɏ㏑邩ǂݒ肷B<br>
     * ftHgĺufalsei㏑ȂjvB
     * </p>
     */
    boolean overWriteFlg() default false;
}
